package com.jeesharp.business.modules.mall.controller;

import com.jeesharp.business.modules.mall.application.MallSeckillSkuApplicationService;
import com.jeesharp.business.modules.mall.dto.MallSeckillSkuSaveDTO;
import com.jeesharp.business.modules.mall.vo.MallSeckillSkuInfoVO;
import com.jeesharp.business.modules.mall.vo.MallSeckillSkuListVO;
import com.jeesharp.business.modules.mall.vo.MallSeckillSkuQueryVO;
import com.jeesharp.framework.pojo.AjaxResult;
import com.jeesharp.framework.pojo.Page;
import com.jeesharp.framework.pojo.query.PageRespVO;
import com.jeesharp.framework.web.controller.BaseController;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

import jakarta.validation.Valid;

/**
 * 秒杀商品管理 Controller
 */
@RestController
@RequestMapping(value = "${jeesharp.web.adminPath}/manager/business/mall/seckill/sku/v1")
@Tag(name = "秒杀商品管理")
@AllArgsConstructor
public class MallSeckillSkuController extends BaseController {

    private final MallSeckillSkuApplicationService mallSeckillSkuApplicationService;

    @Operation(summary = "获取详情")
    @GetMapping(value = "info")
    public AjaxResult<MallSeckillSkuInfoVO> info(@RequestParam("id") String id) {
        MallSeckillSkuInfoVO vo = mallSeckillSkuApplicationService.get(id);
        return AjaxResult.okData(vo);
    }

    @Operation(summary = "获取列表（分页）")
    @PostMapping(value = "list")
    public AjaxResult<PageRespVO<MallSeckillSkuListVO>> list(@RequestBody MallSeckillSkuQueryVO query) {
        PageRespVO<MallSeckillSkuListVO> page = mallSeckillSkuApplicationService.findPage(new Page<>(query), query);
        return AjaxResult.okData(page);
    }

    @Operation(summary = "保存")
    @PostMapping(value = "save")
    public AjaxResult<Void> save(@RequestBody @Valid MallSeckillSkuSaveDTO dto) {
        mallSeckillSkuApplicationService.save(dto);
        return AjaxResult.ok("保存成功");
    }

    @Operation(summary = "删除")
    @GetMapping(value = "delete")
    public AjaxResult<Void> delete(@RequestParam("ids") String ids) {
        mallSeckillSkuApplicationService.delete(ids);
        return AjaxResult.ok("删除成功");
    }
}
